# NX Graphics Subsystem Last Updated: April 5, 2015

# Table of Contents

1.0 Introduction 1.1 Overview 1.2 Objectives 1.3 Organization 1.3.1 NX Graphics Library (`NXGL`) 1.3.2 NX (NXSU and NXMU) 1.3.3 NX Tool Kit (`NXTK`) 1.3.4 NX Fonts Support (`NXFONTS`) 1.3.5 NX Widgets (`NxWidgets`) 1.3.6 NX Terminal Driver (`NxTerm`) 2.0 NX User APIs 2.1 NX Header Files 2.2 NX Graphics Library (`NXGL`) 2.2.1 NXGL Types 2.2.1 `nxgl_rgb2yuv()` 2.2.2 `nxgl_yuv2rgb()` 2.2.3 `nxgl_rectcopy()` 2.2.4 `nxgl_rectoffset()` 2.2.5 `nxgl_vectoradd()` 2.2.6 `nxgl_vectorsubtract()` 2.2.7 `nxgl_rectintersect()` 2.2.8 `nxgl_rectunion()` 2.2.9 `nxgl_nonintersecting()` 2.2.10 `nxgl_rectoverlap()` 2.2.11 `nxgl_rectinside()` 2.2.12 `nxgl_rectsize()` 2.2.13 `nxgl_nullrect()` 2.2.14 `nxgl_runoffset()` 2.2.15 `nxgl_runcopy()` 2.2.16 `nxgl_trapoffset()` 2.2.17 `nxgl_trapcopy()` 2.2.18 `nxgl_colorcopy` 2.2.19 `nxgl_splitline()` 2.2.20 `nxgl_circlepts()` 2.2.21 `nxgl_circletraps()` 2.3 NX 2.3.1 Pre-Processor Definitions 2.3.2 NX Types 2.3.3 NX Server Callbacks 2.3.3.1 `redraw()` 2.3.3.2 `position()` 2.3.3.3 `mousein()` 2.3.3.4 `kbdin()` 2.3.4 `nx_runinstance()` (and `nx_run()`macro)`` 2.3.5 `nx_connectinstance()` (and `nx_connect()` macro) 2.3.6 `nx_open()` 2.3.7 `nx_disconnect()` 2.3.8 `nx_close()` 2.3.9 `nx_eventhandler()` 2.3.10 `nx_eventnotify()` 2.3.11 `nx_openwindow()` 2.3.12 `nx_closewindow()` 2.3.13 `nx_requestbkgd()` 2.3.14 `nx_releasebkgd()` 2.3.15 `nx_getposition()` 2.3.16 `nx_setposition()` 2.3.17 `nx_setsize()` 2.3.18 `nx_raise()` 2.3.19 `nx_lower()` 2.3.20 `nx_fill()` 2.3.21 `nx_getrectangle()` 2.3.22 `nx_filltrapezoid()` 2.3.23 `nx_drawline()` 2.3.24 `nx_drawcircle()` 2.3.25 `nx_fillcircle()` 2.3.26 `nx_setbgcolor()` 2.3.27 `nx_move()` 2.3.28 `nx_bitmap()` 2.3.29 `nx_kbdin()` 2.3.30 `nx_mousein()` | 2.4 NX Tool Kit (`NXTK`) 2.4.1 `NXTK Types()` 2.4.2 `nxtk_openwindow()` 2.4.3 `nxtk_closewindow()` 2.4.4 `nxtk_getposition()` 2.4.5 `nxtk_setposition()` 2.4.6 `nxtk_setsize()` 2.4.7 `nxtk_raise()` 2.4.8 `nxtk_lower()` 2.4.9 `nxtk_fillwindow()` 2.4.10 `nxtk_getwindow()` 2.4.11 `nxtk_filltrapwindow()` 2.4.12 `nxtk_drawlinewindow()` 2.4.13 `nxtk_drawcirclewindow()` 2.4.14 `nxtk_fillcirclewindow()` 2.4.15 `nxtk_movewindow()` 2.4.16 `nxtk_bitmapwindow()` 2.4.17 `nxtk_opentoolbar()` 2.4.18 `nxtk_closetoolbar()` 2.4.19 `nxtk_filltoolbar()` 2.4.20 `nxtk_gettoolbar()` 2.4.21 `nxtk_filltraptoolbar()` 2.4.22 `nxtk_drawlinetoolbar()` 2.4.23 `nxtk_drawcircletoolbar()` 2.4.24 `nxtk_fillcircletoolbar()` 2.4.25 `nxtk_movetoolbar()` 2.4.26 `nxtk_bitmaptoolbar()` 2.5 NX Fonts Support (`NXFONTS`) 2.5.1 `NXFONTS Types()` 2.5.2 `nxf_getfonthandle()` 2.5.3 `nxf_getfontset()` 2.5.4 `nxf_getbitmap()` 2.5.5 `nxf_convert_*bpp()` 2.6 Sample Code Appendix A `graphics/` Directory Structure Appendix B NX Configuration Options B.1 General Configuration Settings B.2 NXGL Configuration Settings B.3 NX Configuration Settings B.4 NX Multi-User (Only) Configuration Settings B.5 NXTK Configuration Settings B.6 NXFONTS Configuration Settings B.7 NxTerm Configuration Settings Appendix C Installing New Fonts Appendix D NX Test Coverage Table D.1: NXGLIB API Test Coverage Table D.2: NX Server Callbacks Test Coverage Table D.3: NX API Test Coverage Table D.4: NXTK API Test Coverage Table D.5: NXFONTS API Test Coverage

# 1.0 Introduction

## 1.1 Overview

This document describes the tiny graphics support included in NuttX. It includes an overview description of that graphics support, detailed descriptions of the NuttX graphics APIs, and discussion of code organization, and OS configuration options.

Figure 1. This scren shot shows the final frame for the NuttX example at `apps/examples/nx` running on the simulated, Linux x86 platform with simulated framebuffer output to an X window. This picture shows to framed windows with (blank) toolbars. Each window has displayed text as received from the NX keyboard interface The second window has just been raised to the top of the display.

## 1.2 Objectives

The objective of this development was to provide a tiny windowing system in the spirit of X, but greatly scaled down and appropriate for most resource-limited embedded environments. The current NX implementation supports the general following, high-level features:

- Virtual Vertical Graphics Space. Windows that reside in a virtual, vertical space so that it makes sense to talk about one window being on top of another and obscuring the window below it.
- Client/Server Model. A standard client server/model was adopted. NX may be considered a server and other logic that presents the windows are NX clients.
- Single- and Multi-User Support. NX includes front-end logic to either a simple single-thread/single-user architecture or a separate NX server thread that can serve multiple NX client threads. In the single-user case, the NX server is simply a set of library calls; in the multi-user case, NX is a server thread/daemon the serializes graphics operations from multiple clients. Other some unique start-up/connection logic, the APIs supported by the single-user and multi-user front-ends are identical. Providing both front-ends is consistent with the NuttX commitment to scalability.
- Minimal Graphics Toolset. The actual implementation of the graphics operations is performed by common, back-end logic. This back-end supports only a primitive set of graphic and rendering operations.
- Device Interface. NX supports any graphics device either of two device interfaces:
  - Any device with random accesss video memory using the NuttX framebuffer driver interface (see `include/nuttx/video/fb.h`).
  - Any LCD-like device than can accept raster line runs through a parallel or serial interface (see `include/nuttx/lcd/lcd.h`). By default, NX is configured to use the frame buffer driver unless `CONFIG_NX_LCDDRIVER` is defined =y in your NuttX configuration file.
- Transparent to NX Client. The window client on "sees" the sub-window that is operates in and does not need to be concerned with the virtual, vertical space (other that to respond to redraw requests from NX when needed).
- Framed Windows and Toolbars. NX also adds the capability to support windows with frames and toolbars on top of the basic windowing support. These are windows such as those shown in the screenshot above. These framed windows sub-divide one one window into three relatively independent subwindows: A frame, the contained window and an (optional) toolbar window.
- Mouse Support. NX provides support for a mouse or other X/Y pointing devices. APIs are provided to allow external devices to give X/Y position information and mouse button presses to NX. NX will then provide the mouse input to the relevant window clients via callbacks. Client windows only receive the mouse input callback if the mouse is positioned over a visible portion of the client window; X/Y position is provided to the client in the relative coordinate system of the client window.
- Keyboard input. NX also supports keyboard/keypad devices. APIs are provided to allow external devices to give keypad information to NX. NX will then provide the mouse input to the top window on the display (the window that has the focus) via a callback function.

## 1.3 Organization

NX is organized into 6 (and perhaps someday 7 or 8) logical modules. These logical modules also correspond to the directory organization. That NuttX directory organization is discussed in Appendix B of this document. The logic modules are discussed in the following sub-paragraphs.

### 1.3.1 NX Graphics Library (`NXGL`)

NXGLIB is a standalone library that contains low-level graphics utilities and direct framebuffer or LCD rendering logic. NX is built on top NXGLIB.

### 1.3.2 NX (`NXSU` and `NXMU`)

NX is the tiny NuttX windowing system for raw windows (i.e., simple regions of graphics memory). NX includes both a small-footprint, single user implementaton (NXSU) and a somewhat larger multi-user implentation (NXMU as described below). Both conform to the same APIs as defined in `include/nuttx/nx/nx.h` and, hence, are interchangable1. NX can be used without NxWidgets and without NXTOOLKIT for raw window displays.

1NXMU and NXSU are interchangeable other than (1) certain start-up and initialization APIs (as described below), and (2) timing. With NXSU, NX APIs execute immediately; with NXMU, NX APIs defer and serialize the operations and, hence, introduce different timing and potential race conditions that you would not experience with NXSU.

NXNULL? At one time, I also envisioned a NULL front-end that did not support windowing at all but, rather, simply provided the entire framebuffer or LCD memory as one dumb window. This has the advantage that the same NX APIs can be used on the one dumb window as for the other NX windows. This would be in the NuttX spirit of scalability.

However, the same end result can be obtained by using the `nx_requestbkgd()` API. It still may be possible to reduce the footprint in this usage case by developing and even thinner NXNULL front-end. That is a possible future development.

### 1.3.3 NX Tool Kit (`NXTK`)

NXTK is a s set of C graphics tools that provide higher-level window drawing operations. This is the module where the framed windows and toolbar logic is implemented. NXTK is built on top of NX and does not depend on NxWidgets.

### 1.3.4 NX Fonts Support (`NXFONTS`)

A set of C graphics tools for present (bitmap) font images. The font implementation is at a very low level or graphics operation, comparable to the logic in NXGLIB. NXFONTS does not depend on any NX module other than some utilities and types from NXGLIB.

### 1.3.5 NX Widgets (`NxWidgets`)

NxWidgets is a higher level, C++, object-oriented library for object-oriented access to graphical "widgets." NxWidgets is provided as a separate package. NxWidgets is built on top of the core NuttX graphics subsystem, but is not a part of the core graphics subystems.

### 1.3.6 NX Terminal Driver (`NxTerm`)

NxTerm is a write-only character device (not shown) that is built on top of an NX window. This character device can be used to provide `stdout` and `stderr` and, hence, can provide the output side of NuttX console. NxTerm is only available when the multi-user NX implementation is selected (`CONFIG_NX_MULTIUSER`).

# 2.0 NX User APIs

## 2.1 NX Header Files

`include/nuttx/nx/nxglib.h`
  Describes the NXGLIB C interfaces
`include/nuttx/nx/nx.h`
  Describes the NX C interfaces
`include/nutt/nxtk.h`
  Describe the NXTOOLKIT C interfaces
`include/nutt/nxfont.h`
  Describe sthe NXFONT C interfaces

## 2.2 NX Graphics Library (`NXGL`)

NXGL provides many APIs, some available for use internally by NX and others for use by applications as well. Only those APIs intended for application usage are documented here See `include/nuttx/nx/nxglib.h` for the full set of APIs; those APIs might be of interest if you are rendering directly into framebuffer or LCD memory.

### 2.2.1 NXGL Types

`nxgl_mxpixel_t`. Holds one device pixel. NXGLIB will select the smallest size for the `nxgl_mxpixel_t` that just contains the pixel: `byte` if 16, 24, and 32 resolution support is disabled, `uint16_t` if 24, and 32 resolution support is disabled, or `uint32_t`.

`nxgl_coord_t`. A given coordinate is limited to the screen height an width. If either of those values exceed 32,767 pixels, then the following will have to need to change:

    typedef int16_t nxgl_coord_t;

`struct nxgl_point_s`. Describes a point on the display:

    struct nxgl_point_s
    {
      nxgl_coord_t x;         /* X position, range: 0 to screen width - 1 */
      nxgl_coord_t y;         /* Y position, range: 0 to screen height - 1 */
    };

`struct nxgl_size_s`. Describes the size of a rectangular region.

    struct nxgl_size_s
    {
      nxgl_coord_t w;        /* Width in pixels */
      nxgl_coord_t h;        /* Height in rows */
    };

`struct nxgl_rect_s`. Describes a positioned rectangle on the display.

    struct nxgl_rect_s
    {
      struct nxgl_point_s pt1; /* Upper, left-hand corner */
      struct nxgl_point_s pt2; /* Lower, right-hand corner */
    };

`struct nxgl_run_s`. Describes a run, i.e., a horizontal line. Note that the start/end positions have fractional precision. This is necessary for good joining of trapezoids when a more complex shape is decomposed into trapezoids

    struct nxgl_run_s
    {
      b16_t        x1;        /* Left X position, range: 0 to x2 */
      b16_t        x2;        /* Right X position, range: x1 to screen width - 1 */
      nxgl_coord_t y;         /* Top Y position, range: 0 to screen height - 1 */
    };

`struct nxgl_trapezoid_s`. Describes a horizontal trapezoid on the display in terms the run at the top of the trapezoid and the run at the bottom

    struct nxgl_trapezoid_s
    {
      struct nxgl_run_s top;  /* Top run */
      struct nxgl_run_s bot;  /* bottom run */
    };

### 2.2.1 `nxgl_rgb2yuv()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    void nxgl_rgb2yuv(uint8_t r, uint8_t g, uint8_t b, uint8_t *y, uint8_t *u, uint8_t *v);

Description: Convert 8-bit RGB triplet to 8-bit YUV triplet.

### 2.2.2 `nxgl_yuv2rgb()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    void nxgl_yuv2rgb(uint8_t y, uint8_t u, uint8_t v, uint8_t *r, uint8_t *g, uint8_t *b);

Description: Convert 8-bit RGB triplet to 8-bit YUV triplet.

### 2.2.3 `nxgl_rectcopy()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    void nxgl_rectcopy(FAR struct nxgl_rect_s *dest,
                       FAR const struct nxgl_rect_s *src);

Description: This is essentially `memcpy()`for rectangles. We don't do structure assignments because some compilers are not good at that.

### 2.2.4 `nxgl_rectoffset()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    void nxgl_rectoffset(FAR struct nxgl_rect_s *dest,
                         FAR const struct nxgl_rect_s *src,
                         nxgl_coord_t dx, nxgl_coord_t dy);

Description: Offset the rectangle position by the specified dx, dy values.

### 2.2.5 `nxgl_vectoradd()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    void nxgl_vectoradd(FAR struct nxgl_point_s *dest,
                        FAR const struct nxgl_point_s *v1,
                        FAR const struct nxgl_point_s *v2);

Description: Add two 2x1 vectors and save the result to a third.

### 2.2.6 `nxgl_vectorsubtract()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    void nxgl_vectsubtract(FAR struct nxgl_point_s *dest,
                           FAR const struct nxgl_point_s *v1,
                           FAR const struct nxgl_point_s *v2);

Description: Add subtract vector `v2` from vector `v1` and return the result in vector dest.

### 2.2.7 `nxgl_rectintersect()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    void nxgl_rectintersect(FAR struct nxgl_rect_s *dest,
                            FAR const struct nxgl_rect_s *src1,
                            FAR const struct nxgl_rect_s *src2);

Description: Return the rectangle representing the intersection of the two rectangles.

### 2.2.8 `nxgl_rectunion()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    void nxgl_rectunion(FAR struct nxgl_rect_s *dest,
                        FAR const struct nxgl_rect_s *src1,
                        FAR const struct nxgl_rect_s *src2);

Description: Given two rectanges, `src1` and `src2`, return the larger rectangle that contains both, `dest`.

### 2.2.9 `nxgl_nonintersecting()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    nxgl_nonintersecting(FAR struct nxgl_rect_s result[4],
                         FAR const struct nxgl_rect_s *rect1,
                         FAR const struct nxgl_rect_s *rect2);

Description: Return the regions of rectangle `rect1` that do not intersect with `rect2`. This will four rectangles, some of which may be degenerate (and can be picked off with `nxgl_nullrect()`).

### 2.2.10 `nxgl_rectoverlap()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    bool nxgl_rectoverlap(FAR struct nxgl_rect_s *rect1,
                          FAR struct nxgl_rect_s *rect2);

Description: Return true if the two rectangles overlap.

### 2.2.11 `nxgl_rectinside()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    bool nxgl_rectinside(FAR const struct nxgl_rect_s *rect,
                         FAR const struct nxgl_point_s *pt);

Description: Return true if the point `pt` lies within `rect`.

### 2.2.12 `nxgl_rectsize()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    void nxgl_rectsize(FAR struct nxgl_size_s *size,
                       FAR const struct nxgl_rect_s *rect);

Description: Return the size of the specified rectangle.

### 2.2.13 `nxgl_nullrect()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    bool nxgl_nullrect(FAR const struct nxgl_rect_s *rect);

Description: Return true if the area of the retangle is <= 0.

### 2.2.14 `nxgl_runoffset()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    void nxgl_runoffset(FAR struct nxgl_run_s *dest,
                        FAR const struct nxgl_run_s *src,
                        nxgl_coord_t dx, nxgl_coord_t dy);

Description: Offset the run position by the specified `dx`, `dy` values.

### 2.2.15 `nxgl_runcopy()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    void nxgl_runcopy(FAR struct nxgl_run_s *dest,
                      FAR const struct nxgl_run_s *src);

Description: This is essentially `memcpy()`for runs. We don't do structure assignments because some compilers are not good at that.

### 2.2.16 `nxgl_trapoffset()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    void nxgl_trapoffset(FAR struct nxgl_trapezoid_s *dest,
                         FAR const struct nxgl_trapezoid_s *src,
                         nxgl_coord_t dx, nxgl_coord_t dy);

Description: Offset the trapezoid position by the specified `dx`, `dy` values.

### 2.2.17 `nxgl_trapcopy()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    void nxgl_trapcopy(FAR struct nxgl_trapezoid_s *dest,
                       FAR const struct nxgl_trapezoid_s *src);

Description: This is essentially `memcpy()`for trapezoids. We don't do structure assignments because some compilers are not good at that.

### 2.2.18 `nxgl_colorcopy`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    nxgl_colorcopy(nxgl_mxpixel_t dest[CONFIG_NX_NPLANES],
                   const nxgl_mxpixel_t src[CONFIG_NX_NPLANES]);

Description: This is essentially `memcpy()`for colors. This does very little for us other than hide all of the conditional compilation for planar colors in one place.

### 2.2.19 `nxgl_splitline`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    int nxgl_splitline(FAR struct nxgl_vector_s *vector, FAR struct nxgl_trapezoid_s *traps,
                       FAR struct nxgl_rect_s *rect, nxgl_coord_t linewidth);

Description: In the general case, a line with width can be represented as a parallelogram with a triangle at the top and bottom. Triangles and parallelograms are both degenerate versions of a trapezoid. This function breaks a wide line into triangles and trapezoids. This function also detects other degenerate cases:

1. If `y1 == y2` then the line is horizontal and is better represented as a rectangle.
2. If `x1 == x2` then the line is vertical and also better represented as a rectangle.
3. If the width of the line is 1, then there are no triangles at the top and bottom (this may also be the case if the width is narrow and the line is near vertical).
4. If the line is oriented is certain angles, it may consist only of the upper and lower triangles with no trapezoid in between. In this case, 3 trapezoids will be returned, but traps[1] will be degenerate.

Input parameters:

`vector`
  A pointer to the vector described the line to be drawn.
`traps`
  A pointer to a array of trapezoids (size 3).
`rect`
  A pointer to a rectangle.

Returned value:

`0`: Line successfully broken up into three trapezoids. Values in `traps[0]`, `traps[1]`, and `traps[2]` are valid.

`1`: Line successfully represented by one trapezoid. Value in `traps[1]` is valid.

`2`: Line successfully represented by one rectangle. Value in `rect` is valid

`<0`: On errors, a negated `errno` value is returned.

### 2.2.20 `nxgl_circlepts`

    #include <nuttx/nx/nxglib.h>
    void nxgl_circlepts(FAR const struct nxgl_point_s *center, nxgl_coord_t radius,
                        FAR struct nxgl_point_s *circle);

Description: Given a description of a circle, return a set of 16 points on the circumference of the circle. These points may then be used by `nx_drawcircle()` or related APIs to draw a circle outline.

Input parameters:

`center`
  A pointer to the point that is the center of the circle.
`radius`
  The radius of the circle in pixels.
`circle`
  A pointer the first entry in an array of 16 points where the circle points will be returned.

Returned value: None

### 2.2.21 `nxgl_circletraps`

    #include <nuttx/nx/nxglib.h>
    oid nxgl_circletraps(FAR const struct nxgl_point_s *center, nxgl_coord_t radius,
                         FAR struct nxgl_trapezoid_s *circle);

Description: Given a description of a a circle, return 8 trapezoids that can be used to fill the circle by `nx_fillcircle()` and other interfaces.

Input parameters:

`center`
  A pointer to the point that is the center of the circle.
`radius`
  The radius of the circle in pixels.
`circle`
  A pointer the first entry in an array of 8 trapezoids where the circle description will be returned.

Returned value: None

## 2.3 NX

### 2.3.1 Pre-Processor Definitions

The default server message queue name used by the `nx_run()` macro:

    #define NX_DEFAULT_SERVER_MQNAME "/dev/nxs"

Mouse button bits:

    #define NX_MOUSE_NOBUTTONS    0x00
    #define NX_MOUSE_LEFTBUTTON   0x01
    #define NX_MOUSE_CENTERBUTTON 0x02
    #define NX_MOUSE_RIGHTBUTTON  0x04

### 2.3.2 NX Types

The interface to the NX server is managed using a opaque handle:

    typedef FAR void *NXHANDLE;

The interface to a specific window is managed using an opaque handle:

    typedef FAR void *NXWINDOW;

These define callbacks that must be provided to `nx_openwindow()`. In the multi-user model, these callbacks will be invoked as part of the processing performed by `nx_eventhandler()`.

    struct nx_callback_s
    {
      void (*redraw)(NXWINDOW hwnd, FAR const struct nxgl_rect_s *rect,
                     bool more, FAR void *arg);
      void (*position)(NXWINDOW hwnd, FAR const struct nxgl_size_s *size,
                       FAR const struct nxgl_point_s *pos,
                       FAR const struct nxgl_rect_s *bounds,
                       FAR void *arg);
    #ifdef CONFIG_NX_XYINPUT
      void (*mousein)(NXWINDOW hwnd, FAR const struct nxgl_point_s *pos,
                      uint8_t buttons, FAR void *arg);
    #endif
    #ifdef CONFIG_NX_KBD
      void (*kbdin)(NXWINDOW hwnd, uint8_t nch, FAR const uint8_t *ch, FAR void *arg);
    #endif
    };

### 2.3.3 NX Server Callbacks

#### 2.3.3.1 `redraw()`

Callback Function Prototype:

    void redraw(NXWINDOW hwnd, FAR const struct nxgl_rect_s *rect,
                bool more, FAR void *arg);

Description: NX requests that the client re-draw the portion of the window within with rectangle.

Input Parameters:

`hwnd`
  The handle created by `nx_openwindow()` or `nx_requestbkgd()`
`rect`
  The rectangle that needs to be re-drawn (in window relative coordinates)
`more`
  true: More re-draw requests will follow
`arg`
  User provided argument (see `nx_openwindow()`)

Returned Value: None

#### 2.3.3.2 `position()`

Callback Function Prototype:

    void position(NXWINDOW hwnd, FAR const struct nxgl_size_s *size,
                  FAR const struct nxgl_point_s *pos,
                  FAR const struct nxgl_rect_s *bounds,
                  FAR void *arg);

Description: The size or position of the window has changed (or the window was just created with zero size.

Input Parameters:

`hwnd`
  The handle created by `nx_openwindow()` or `nx_requestbkgd()`
`size`
  The size of the window
`pos`
  The position of the upper left hand corner of the window on the overall display
`bounds`
  The bounding rectangle that the describes the entire display
`arg`
  User provided argument (see `nx_openwindow()`)

Returned Value: None

#### 2.3.3.3 `mousein()`

Callback Function Prototype:

    #ifdef CONFIG_NX_XYINPUT
    void mousein(NXWINDOW hwnd, FAR const struct nxgl_point_s *pos,
                 uint8_t buttons, FAR void *arg);
    #endif

Description: New mouse data is available for the window

Input Parameters:

`hwnd`
  The handle created by `nx_openwindow()` or `nx_requestbkgd()`
`pos`
  The (x,y) position of the mouse
`buttons`
  See `NX_MOUSE_*` definitions
`arg`
  User provided argument (see `nx_openwindow()`)

Returned Value: None

#### 2.3.3.4 `kbdin()`

Callback Function Prototype:

    #ifdef CONFIG_NX_KBD
    void (*kbdin)(NXWINDOW hwnd, uint8_t nch, FAR const uint8_t *ch, FAR void *arg);
    #endif

Description: New keyboard/keypad data is available for the window.

Input Parameters:

`hwnd`
  The handle created by `nx_openwindow()` or `nx_requestbkgd()`
`nch`
  The number of characters that are available in ch[]
`ch`
  The array of characters
`arg`
  User provided argument (see `nx_openwindow()`)

Returned Value: None

### 2.3.4 `nx_runinstance()` (and `nx_run()` macro)

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    #ifdef CONFIG_NX_MULTIUSER
    int nx_runinstance(FAR const char *mqname, FAR struct fb_vtable_s *fb);
    #define nx_run(fb) nx_runinstance(NX_DEFAULT_SERVER_MQNAME, dev)
    #endif

Description: This is the server entry point. It does not return; the calling thread is dedicated to supporting NX server.

NOTE that multiple instances of the NX server may run at the same time, with different callback and message queue names. `nx_run()` is simply a macro that can be used when only one server instance is required. In that case, a default server name is used.

Multiple user mode only!

Input Parameters:

`mqname`
  - The name for the server incoming message queue
`dev`
  Framebuffer or LCD driver "object" to be used

Returned Value: This function usually does not return. If it does return, it will return `ERROR` and `errno` will be set appropriately.

### 2.3.5 `nx_connectinstance()` (and `nx_connect()` macro)

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    #ifdef CONFIG_NX_MULTIUSER
    NXHANDLE nx_connectinstance(FAR const char *svrmqname);
    #define nx_connect(cb) nx_connectinstance(NX_DEFAULT_SERVER_MQNAME)
    #endif

Description: Open a connection from a client to the NX server. One one client connection is normally needed per thread as each connection can host multiple windows.

NOTES:

- This function returns before the connection is fully instantiated. it is necessary to wait for the connection event before using the returned handle.
- Multiple instances of the NX server may run at the same time, each with different message queue names.
- `nx_connect()` is simply a macro that can be used when only one server instance is required. In that case, a default server name is used.

Multiple user mode only!

Input Parameters:

`svrmqname`
  The name for the server incoming message queue

Returned Value:

Success: A non-NULL handle used with subsequent NX accesses
Failure: NULL is returned and `errno` is set appropriately.

### 2.3.6 `nx_open()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    #ifndef CONFIG_NX_MULTIUSER
    NXHANDLE nx_open(FAR struct fb_vtable_s *dev);
    #endif

Description: Create, initialize and return an NX handle for use in subsequent NX API calls. `nx_open()` is the single user equivalent of `nx_connect()` plus `nx_run()`.

Single user mode only!

Input Parameters:

`dev`
  Frame buffer or LCD driver "object" to be used.
`cb`
  Callbacks used to process received NX server messages

Returned Value:

Success: A non-NULL handle used with subsequent NX accesses
Failure: NULL is returned and `errno` is set appropriately.

### 2.3.7 `nx_disconnect()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    #ifdef CONFIG_NX_MULTIUSER
    void nx_disconnect(NXHANDLE handle);
    #endif

Description: Disconnect a client from the NX server and/or free resources reserved by `nx_connect()`/`nx_connectinstance()`. `nx_disconnect()` is muliti-user equivalent of `nx_close()`.

Multiple user mode only!

Input Parameters:

`handle`
  The handle returned by `nx_connect()`.

Returned Value: None.

### 2.3.8 `nx_close()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    #ifndef CONFIG_NX_MULTIUSER
    void nx_close(NXHANDLE handle);
    #endif

Description: Close the single user NX interface. nx_close is single-user equivalent of `nx_disconnect()`.

Single user mode only!

Input Parameters:

`handle`
  The handle returned by `nx_open()`.

Returned Value: None

### 2.3.9 `nx_eventhandler()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    #ifdef CONFIG_NX_MULTIUSER
    int nx_eventhandler(NXHANDLE handle);
    #else
    #  define nx_eventhandler(handle) (OK)
    #endif

Description: The client code must call this function periodically to process incoming messages from the server. If `CONFIG_NX_BLOCKING` is defined, then this function not return until a server message is received.

When `CONFIG_NX_BLOCKING` is not defined, the client must exercise caution in the looping to assure that it does not eat up all of the CPU bandwidth calling nx_eventhandler repeatedly. `nx_eventnotify()` may be called to get a signal event whenever a new incoming server event is avaiable.

Input Parameters:

`handle`
  The handle returned by `nx_connect()`.

Returned Value:

- `OK`: No errors occurred. If `CONFIG_NX_BLOCKING` is defined, then one or more server messages were processed.
- `ERROR`: An error occurred and `errno` has been set appropriately. Of particular interest, it will return `errno == EHOSTDOWN` when the server is disconnected. After that event, the handle can no longer be used.

### 2.3.10 `nx_eventnotify()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    #if defined(CONFIG_NX_MULTIUSER) && !defined(CONFIG_DISABLE_SIGNALS)
    int nx_eventnotify(NXHANDLE handle, int signo);
    #else
    #  define nx_eventnotify(handle, signo) (OK)
    #endif

Description: Rather than calling `nx_eventhandler()` periodically, the client may register to receive a signal when a server event is available. The client can then call `nv_eventhandler()` only when incoming events are available.

The underlying implementation used `mq_notifiy()` and, as a result, the client must observe the rules for using `mq_notifiy()`:

- Only one event is signalled. Upon receipt of the signal, if the client wishes further notifications, it must call `nx_eventnotify()` again.
- The signal will only be issued when the message queue transitions from empty to not empty.

Input Parameters:

`handle`
  The handle returned by `nx_connect()`.

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.11 `nx_openwindow()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    NXWINDOW nx_openwindow(NXHANDLE handle,
                           FAR const struct nx_callback_s *cb,
                           FAR void *arg);

Description: Create a new window.

Input Parameters:

`handle`
  The handle returned by `nx_connect()` or `nx_open()`.
`cb`
  Callbacks used to process window events
`arg`
  User provided value that will be returned with NX callbacks.

Returned Value:

Success: A non-NULL handle used with subsequent NX accesses
Failure: NULL is returned and `errno` is set appropriately.

### 2.3.12 `nx_closewindow()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    int nx_closewindow(NXWINDOW hwnd);

Description: Destroy a window created by `nx_openwindow()` window.

Input Parameters:

`hwnd`
  The handle returned by `nx_openwindow()` that identifies the window to be destroyed. This handle must not have been one returned by `nx_requestbkgd()`.

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.13 `nx_requestbkgd()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    int nx_requestbkgd(NXHANDLE handle,
                       FAR const struct nx_callback_s *cb,
                       FAR void *arg);

Description: NX normally controls a separate window called the background window. It repaints the window as necessary using only a solid color fill. The background window always represents the entire screen and is always below other windows. It is useful for an application to control the background window in the following conditions:

- If you want to implement a windowless solution. The single screen can be used to create a truly simple graphic environment. In this case, you should probably also de-select `CONFIG_NX_MULTIUSER` as well.
- When you want more on the background than a solid color. For example, if you want an image in the background, or animations in the background, or live video, etc.

This API only requests the handle of the background window. That handle will be returned asynchronously in a subsequent position and redraw callbacks.

Cautions:

- The following should never be called using the background window. They are guaranteed to cause severe crashes: `nx_setposition()`, `nx_setsize()`, `nx_raise()`, or `nx_lower()`.
- Neither `nx_requestbkgd()` nor `nx_releasebkgd ()` should be called more than once. Multiple instances of the background window are not supported.

Input Parameters:

`handle`
  The handle returned by `nx_connect()` or `nx_open()`.
`cb`
  Callbacks to use for processing background window events
`arg`
  User provided argument (see `nx_openwindow()`)

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.14 `nx_releasebkgd()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    int nx_releasebkgd(NXWINDOW hwnd);

Description: Release the background window previously acquired using `nx_requestbkgd()` and return control of the background to NX.

Input Parameters:

`handle`
  The handle returned indirectly by `nx_requestbkgd()`. This handle must not have been one created by `nx_openwindow()`.

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.15 `nx_getposition()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    int nx_getposition(NXWINDOW hwnd);

Description: Request the position and size information for the selected window. The values will be return asynchronously through the client callback function pointer.

Input Parameters:

`hwnd`
  The handle returned by `nx_openwindow()` or `nx_requestbkgd()`.

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.16 `nx_setposition()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    int nx_setposition(NXWINDOW hwnd, FAR struct nxgl_point_s *pos);

Description: Set the position and size for the selected window.

Input Parameters:

`hwnd`
  The handle returned by `nx_openwindow()`. This handle must not have been created by `nx_requestbkgd()`.
`pos`
  The new position of the window

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.17 `nx_setsize()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    int nx_setsize(NXWINDOW hwnd, FAR struct nxgl_size_s *size);

Description: Set the size of the selected window.

Input Parameters:

`hwnd`
  The handle returned by `nx_openwindow()`. This handle must not have been created by `nx_requestbkgd()`.
`size`
  The new size of the window (in pixels).

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.18 `nx_raise()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    int nx_raise(NXWINDOW hwnd);

Description: Bring the specified window to the top of the display.

Input Parameters:

`hwnd`
  The handle returned by `nx_openwindow()`. This handle must not have been created by `nx_requestbkgd()`.
``

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.19 `nx_lower()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    int nx_lower(NXWINDOW hwnd);

Description: Lower the specified window to the bottom of the display.

Input Parameters:

`hwnd`
  The handle returned by `nx_openwindow()`. This handle must not have been created by `nx_requestbkgd()`.
``

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.20 `nx_fill()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    int nx_fill(NXWINDOW hwnd, FAR const struct nxgl_rect_s *rect,
                       nxgl_mxpixel_t color[CONFIG_NX_NPLANES]);

Description: Fill the specified rectangle in the window with the specified color.

Input Parameters:

`hwnd`
  The handle returned by `nx_openwindow()` or `nx_requestbkgd()`
`rect`
  The location to be filled
`color`
  The color to use in the fill

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.21 `nx_getrectangle()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    void nx_getrectangle(NXWINDOW hwnd, FAR const struct nxgl_rect_s *rect,
                         unsigned int plane, FAR uint8_t *dest,
                         unsigned int deststride);

Description: Get the raw contents of graphic memory within a rectangular region. NOTE: Since raw graphic memory is returned, the returned memory content may be the memory of windows above this one and may not necessarily belong to this window unless you assure that this is the top window.

Input Parameters:

`hwnd`
  The handle returned by `nx_openwindow()` or `nx_requestbkgd()`
`rect`
  The location to be copied
`plane`
  Specifies the color plane to get from
`dest`
  The location to copy the memory region
`deststride`
  The width, in bytes, of the dest memory

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.22 `nx_filltrapezoid()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    int nx_filltrapezoid(NXWINDOW hwnd, FAR const struct nxgl_rect_s *clip,
                                FAR const struct nxgl_trapezoid_s *trap,
                                nxgl_mxpixel_t color[CONFIG_NX_NPLANES]);

Description: Fill the specified trapezoidal region in the window with the specified color.

Input Parameters:

`hwnd`
  The handle returned by `nx_openwindow()` or `nx_requestbkgd()`
`clip`
  Clipping rectangle relative to window (may be null)
`trap`
  The trapezoidal region to be filled
`color`
  The color to use in the fill

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.23 `nx_drawline()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    int nx_drawline(NXWINDOW hwnd, FAR struct nxgl_vector_s *vector,
                   nxgl_coord_t width, nxgl_mxpixel_t color[CONFIG_NX_NPLANES],
                   uint8_t caps);

Description: Fill the specified trapezoidal region in the window with the specified color. Fill the specified line in the window with the specified color. This is simply a wrapper that uses `nxgl_splitline()` to break the line into trapezoids and then calls `nx_filltrapezoid()` to render the line.

Input Parameters:

`hwnd`
  The handle returned by `nx_openwindow()` or `nx_requestbkgd()`
`vector`
  Describes the line to be drawn.
`width`
  The width of the line
`color`
  The color to use to fill the line
`caps`
  Draw a circular cap on the ends of the line to support better line joins. One of:

      /* Line caps */

      #define NX_LINECAP_NONE  0x00, /* No line caps */
      #define NX_LINECAP_PT1   0x01  /* Line cap on pt1 on of the vector only */
      #define NX_LINECAP_PT2   0x02  /* Line cap on pt2 on of the vector only */
      #define NX_LINECAP_BOTH  0x03  /* Line cap on both ends of the vector only */

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.24 `nx_drawcircle()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    int nx_drawcircle(NXWINDOW hwnd, FAR const struct nxgl_point_s *center,
                      nxgl_coord_t radius, nxgl_coord_t width,
                      nxgl_mxpixel_t color[CONFIG_NX_NPLANES]);

Description: Draw a circular outline using the specified line thickness and color.

Input Parameters:

`hwnd`
  The handle returned by `nx_openwindow()` or `nx_requestbkgd()`
`center`
  A pointer to the point that is the center of the circle.
`radius`
  The radius of the circle in pixels.
`width`
  The width of the line
`color`
  The color to use to fill the line

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.25 `nx_fillcircle()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    int nx_fillcircle(NXWINDOW hwnd, FAR const struct nxgl_point_s *center,
                      nxgl_coord_t radius, nxgl_mxpixel_t color[CONFIG_NX_NPLANES]);

Description: Fill a circular region using the specified color.

Input Parameters:

`hwnd`
  The handle returned by `nx_openwindow()` or `nx_requestbkgd()`
`center`
  A pointer to the point that is the center of the circle.
`radius`
  The width of the line
`color`
  The color to use to fill the circle

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.26 `nx_setbgcolor()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    int nx_setbgcolor(NXHANDLE handle,
                      nxgl_mxpixel_t color[CONFIG_NX_NPLANES]);

Description: Set the color of the background.

Input Parameters:

`handle`
  The handle created by `nx_openwindow()` or `nx_requestbkgd()`
`color`
  The color to use in the background

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.27 `nx_move()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    int nx_move(NXWINDOW hwnd, FAR const struct nxgl_rect_s *rect,
                       FAR const struct nxgl_point_s *offset);

Description: Move a rectangular region within the window.

Input Parameters:

`hwnd`
  The handle returned by `nx_openwindow()` or `nx_requestbkgd()` that specifies the window within which the move is to be done
`rect`
  Describes the (source) rectangular region to move
`offset`
  The offset to move the region

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.28 `nx_bitmap()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    int nx_bitmap(NXWINDOW hwnd, FAR const struct nxgl_rect_s *dest,
                         FAR const void *src[CONFIG_NX_NPLANES],
                         FAR const struct nxgl_point_s *origin,
                         unsigned int stride);

Description: Copy a rectangular region of a larger image into the rectangle in the specified window.

Input Parameters:

`hwnd`
  The handle returned by `nx_openwindow()` or `nx_requestbkgd()` that specifies the window that will receive the bitmap image.
`dest`
  Describes the rectangular on the display that will receive the bit map.
`src`
  The start of the source image. This is an array source images of size `CONFIG_NX_NPLANES` (probably 1).
`origin`
  The origin of the upper, left-most corner of the full bitmap. Both dest and origin are in window coordinates, however, the origin may lie outside of the display.
`stride`
  The width of the full source image in bytes.

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.29 `nx_kbdin()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    #ifdef CONFIG_NX_KBD
    int nx_kbdchin(NXHANDLE handle, uint8_t ch);
    int nx_kbdin(NXHANDLE handle, uint8_t nch, FAR const uint8_t *ch);
    #endif

Description: Used by a thread or interrupt handler that manages some kind of keypad hardware to report text information to the NX server. That text data will be routed by the NX server to the appropriate window client.

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.3.30 `nx_mousein()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>

    #ifdef CONFIG_NX_XYINPUT
    int nx_mousein(NXHANDLE handle, nxgl_coord_t x, nxgl_coord_t y, uint8_t buttons);
    #endif

Description: Used by a thread or interrupt handler that manages some kind of pointing hardware to report new positional data to the NX server. That positional data will be routed by the NX server to the appropriate window client.

Input Parameters:

``

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

## 2.4 NX Tool Kit (`NXTK`)

NXTK implements where the framed window. NX framed windows consist of three components within one NX window:

1. The window border,
2. The main client window area, and
3. A toolbar area

Each sub-window represents a region within one window. Figure 1 shows some simple NX framed windows. NXTK allows these sub-windows to be managed more-or-less independently:

- Each component has its own callbacks for redraw and position events as well as mouse and keyboard inputs. The client sub-window callbacks are registered when the framed window is created with a call to `nxtk_openwindow()`; Separate toolbar sub-window callbakcs are reigistered when the toolbar is added using `nxtk_opentoolbar()`. (NOTES: (1) only the client sub-window receives keyboard input and, (2) border callbacks are not currently accessible by the user).
All position informational provided within the callback is relative to the specific sub-window. That is, the origin (0,0) of the coordinate system for each sub-window begins at the top left corner of the subwindow. This means that toolbar logic need not be concerned about client window geometry (and vice versa) and, for example, common toolbar logic can be used with different windows.

### 2.4.1 `NXTK Types()`

This is the handle that can be used to access the window data region.

    typedef FAR void *NXTKWINDOW;

### 2.4.2 `nxtk_openwindow()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    NXTKWINDOW nxtk_openwindow(NXHANDLE handle,
                               FAR const struct nx_callback_s *cb,
                               FAR void *arg);

Description: Create a new, framed window.

Input Parameters:

`handle`
  The handle returned by `nx_connect()` or `nx_open()`.
`cb`
  Callbacks used to process window events
`arg`
  User provided argument (see `nx_openwindow()`)

Returned Value:

Success: A non-NULL handle used with subsequent NXTK window accesses
Failure: NULL is returned and `errno` is set appropriately.

### 2.4.3 `nxtk_closewindow()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_closewindow(NXTKWINDOW hfwnd);

Description: Close the window opened by `nxtk_openwindow()`.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.4 `nxtk_getposition()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_getposition(NXTKWINDOW hfwnd);

Description: Request the position and size information for the selected framed window. The size/position for the client window and toolbar will be return asynchronously through the client callback function pointer.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.5 `nxtk_setposition()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_setposition(NXTKWINDOW hfwnd, FAR struct nxgl_point_s *pos);

Description: Set the position for the selected client window. This position does not include the offsets for the borders nor for any toolbar. Those offsets will be added in to set the full window position.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.
`pos`
  The new position of the client sub-window

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.6 `nxtk_setsize()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_setsize(NXTKWINDOW hfwnd, FAR struct nxgl_size_s *size);

Description: Set the size for the selected client window. This size does not include the sizes of the borders nor for any toolbar. Those sizes will be added in to set the full window size.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.
`size`
  The new size of the client sub-window.

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.7 `nxtk_raise()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_raise(NXTKWINDOW hfwnd);

Description: Bring the window containing the specified client sub-window to the top of the display.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()` specifying the window to be raised.
``

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.8 `nxtk_lower()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_lower(NXTKWINDOW hfwnd);

Description: Lower the window containing the specified client sub-window to the bottom of the display.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()` specifying the window to be lowered.
``

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.9 `nxtk_fillwindow()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_fillwindow(NXTKWINDOW hfwnd, FAR const struct nxgl_rect_s *rect,
                        nxgl_mxpixel_t color[CONFIG_NX_NPLANES]);

Description: Fill the specified rectangle in the client window with the specified color.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.
`rect`
  The location within the client window to be filled
`color`
  The color to use in the fill

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.10 `nxtk_getwindow()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    void nxtk_getwindow(NXTKWINDOW hfwnd, FAR const struct nxgl_rect_s *rect,
                        unsigned int plane, FAR uint8_t *dest,
                        unsigned int deststride);

Description: Get the raw contents of graphic memory within a rectangular region. NOTE: Since raw graphic memory is returned, the returned memory content may be the memory of windows above this one and may not necessarily belong to this window unless you assure that this is the top window.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.
`rect`
  The location within the client window to be retrieved.
`plane`
  Specifies the color plane to get from.
`dest`
  The location to copy the memory region
`deststride`
  The width, in bytes, of the dest memory

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.11 `nxtk_filltrapwindow()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_filltrapwindow(NXTKWINDOW hfwnd,
                            FAR const struct nxgl_trapezoid_s *trap,
                            nxgl_mxpixel_t color[CONFIG_NX_NPLANES]);

Description: Fill the specified trapezoid in the client window with the specified color

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.
`trap`
  The trapezoidal region to be filled.
`color`
  The color to use in the fill.

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.12 `nxtk_drawlinewindow()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_drawlinewindow(NXTKWINDOW hfwnd, FAR struct nxgl_vector_s *vector,
                            nxgl_coord_t width, nxgl_mxpixel_t color[CONFIG_NX_NPLANES],
                            uint8_t caps);

Description: Fill the specified trapezoidal region in the window with the specified color. Fill the specified line in the window with the specified color. This is simply a wrapper that uses `nxgl_splitline()` to break the line into trapezoids and then calls `nxtk_filltrapwindow()` to render the line.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.
`vector`
  Describes the line to be drawn.
`width`
  The width of the line
`color`
  The color to use to fill the line
`caps`
  Draw a circular cap on the ends of the line to support better line joins. One of:

      /* Line caps */

      #define NX_LINECAP_NONE  0x00, /* No line caps */
      #define NX_LINECAP_PT1   0x01  /* Line cap on pt1 on of the vector only */
      #define NX_LINECAP_PT2   0x02  /* Line cap on pt2 on of the vector only */
      #define NX_LINECAP_BOTH  0x03  /* Line cap on both ends of the vector only */

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.13 `nxtk_drawcirclewindow()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_drawcirclewindow(NXTKWINDOW hfwnd, FAR const struct nxgl_point_s *center,
                              nxgl_coord_t radius, nxgl_coord_t width,
                              nxgl_mxpixel_t color[CONFIG_NX_NPLANES]);

Description: Draw a circular outline using the specified line thickness and color.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.
`center`
  A pointer to the point that is the center of the circle.
`radius`
  The radius of the circle in pixels.
`width`
  The width of the line
`color`
  The color to use to fill the line

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.14 `nxtk_fillcirclewindow()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_fillcirclewindow(NXWINDOW hfwnd, FAR const struct nxgl_point_s *center,
                              nxgl_coord_t radius, nxgl_mxpixel_t color[CONFIG_NX_NPLANES]);

Description: Fill a circular region using the specified color.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.
`center`
  A pointer to the point that is the center of the circle.
`radius`
  The width of the line
`color`
  The color to use to fill the circle

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.15 `nxtk_movewindow()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_movewindow(NXTKWINDOW hfwnd, FAR const struct nxgl_rect_s *rect,
                        FAR const struct nxgl_point_s *offset);

Description: Move a rectangular region within the client sub-window of a framed window.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()` specifying the client sub-window within which the move is to be done.
`rect`
  Describes the rectangular region relative to the client sub-window to move.
`offset`
  The offset to move the region

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.16 `nxtk_bitmapwindow()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_bitmapwindow(NXTKWINDOW hfwnd,
                          FAR const struct nxgl_rect_s *dest,
                          FAR const void *src[CONFIG_NX_NPLANES],
                          FAR const struct nxgl_point_s *origin,
                          unsigned int stride);

Description: Copy a rectangular region of a larger image into the rectangle in the specified client sub-window.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()` specifying the client sub-window that will receive the bitmap.
`dest`
  Describes the rectangular region on in the client sub-window will receive the bit map.
`src`
  The start of the source image(s). This is an array source images of size `CONFIG_NX_NPLANES` (probably 1).
`origin`
  The origin of the upper, left-most corner of the full bitmap. Both dest and origin are in sub-window coordinates, however, the origin may lie outside of the sub-window display.
`stride`
  The width of the full source image in pixels.

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.17 `nxtk_opentoolbar()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_opentoolbar(NXTKWINDOW hfwnd, nxgl_coord_t height,
                         FAR const struct nx_callback_s *cb,
                         FAR void *arg);

Description: Create a tool bar at the top of the specified framed window.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.
`height`
  The requested height of the toolbar in pixels.
`cb`
  Callbacks used to process toolbar events.
`arg`
  User provided value that will be returned with toolbar callbacks.

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.18 `nxtk_closetoolbar()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_closetoolbar(NXTKWINDOW hfwnd);

Description: Remove the tool bar at the top of the specified framed window.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.
``

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.19 `nxtk_filltoolbar()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_filltoolbar(NXTKWINDOW hfwnd, FAR const struct nxgl_rect_s *rect,
                         nxgl_mxpixel_t color[CONFIG_NX_NPLANES]);

Description: Fill the specified rectangle in the toolbar sub-window with the specified color.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.
`rect`
  The location within the toolbar window to be filled.
`color`
  The color to use in the fill.

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.19 `nxtk_gettoolbar()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_gettoolbar(NXTKWINDOW hfwnd, FAR const struct nxgl_rect_s *rect,
                        unsigned int plane, FAR uint8_t *dest,
                        unsigned int deststride);

Description: Get the raw contents of graphic memory within a rectangular region. NOTE: Since raw graphic memory is returned, the returned memory content may be the memory of windows above this one and may not necessarily belong to this window unless you assure that this is the top window.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.
`rect`
  The location within the toolbar window to be retrieved.
`plane`
  TSpecifies the color plane to get from.
`dest`
  TThe location to copy the memory region.
`deststride`
  The width, in bytes, of the dest memory.

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.21 `nxtk_filltraptoolbar()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_filltraptoolbar(NXTKWINDOW hfwnd, FAR const struct nxgl_trapezoid_s *trap,
                             nxgl_mxpixel_t color[CONFIG_NX_NPLANES]);

Description: Fill the specified trapezoid in the toolbar sub-window with the specified color.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.
`trap`
  The trapezoidal region to be filled
`color`
  The color to use in the fill

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.22 `nxtk_drawlinetoolbar()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_drawlinetoolbar(NXTKWINDOW hfwnd, FAR struct nxgl_vector_s *vector,
                             nxgl_coord_t width, nxgl_mxpixel_t color[CONFIG_NX_NPLANES],
                             uint8_t caps);

Description: Fill the specified line in the toolbar sub-window with the specified color. This is simply a wrapper that uses `nxgl_splitline()` to break the line into trapezoids and then calls `nxtk_filltraptoolbar()` to render the line.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.
`vector`
  Describes the line to be drawn.
`width`
  The width of the line
`color`
  The color to use to fill the line
`caps`
  Draw a circular cap on the ends of the line to support better line joins. One of:

      /* Line caps */

      #define NX_LINECAP_NONE  0x00, /* No line caps */
      #define NX_LINECAP_PT1   0x01  /* Line cap on pt1 on of the vector only */
      #define NX_LINECAP_PT2   0x02  /* Line cap on pt2 on of the vector only */
      #define NX_LINECAP_BOTH  0x03  /* Line cap on both ends of the vector only */

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.23 `nxtk_drawcircletoolbar()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_drawcircletoolbar(NXTKWINDOW hfwnd, FAR const struct nxgl_point_s *center,
                               nxgl_coord_t radius, nxgl_coord_t width,
                               nxgl_mxpixel_t color[CONFIG_NX_NPLANES]);

Description: Draw a circular outline using the specified line thickness and color.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.
`center`
  A pointer to the point that is the center of the circle.
`radius`
  The radius of the circle in pixels.
`width`
  The width of the line
`color`
  The color to use to fill the line

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.24 `nxtk_fillcircletoolbar()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_fillcircletoolbar(NXWINDOW hfwnd, FAR const struct nxgl_point_s *center,
                               nxgl_coord_t radius, nxgl_mxpixel_t color[CONFIG_NX_NPLANES]);

Description: Fill a circular region using the specified color.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.
`center`
  A pointer to the point that is the center of the circle.
`radius`
  The width of the line
`color`
  The color to use to fill the circle

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.25 `nxtk_movetoolbar()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_movetoolbar(NXTKWINDOW hfwnd, FAR const struct nxgl_rect_s *rect,
                         FAR const struct nxgl_point_s *offset);

Description: Move a rectangular region within the toolbar sub-window of a framed window.

Input Parameters:

`hfwnd`
  A handle identifying sub-window containing the toolbar within which the move is to be done. This handle must have previously been returned by `nxtk_openwindow()`.
`rect`
  Describes the rectangular region relative to the toolbar sub-window to move.
`offset`
  The offset to move the region

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

### 2.4.26 `nxtk_bitmaptoolbar()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nx.h>
    #include <nuttx/nx/nxtk.h>

    int nxtk_bitmaptoolbar(NXTKWINDOW hfwnd,
                           FAR const struct nxgl_rect_s *dest,
                           FAR const void *src[CONFIG_NX_NPLANES],
                           FAR const struct nxgl_point_s *origin,
                           unsigned int stride);

Description: Copy a rectangular region of a larger image into the rectangle in the specified toolbar sub-window.

Input Parameters:

`hfwnd`
  A handle previously returned by `nxtk_openwindow()`.
`dest`
  Describes the rectangular region on in the toolbar sub-window will receive the bit map.
`src`
  The start of the source image.
`origin`
  The origin of the upper, left-most corner of the full bitmap. Both dest and origin are in sub-window coordinates, however, the origin may lie outside of the sub-window display.
`stride`
  The width of the full source image in bytes.

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately

## 2.5 NX Fonts Support (`NXFONTS`)

### 2.5.1 `NXFONTS Types()`

This structures provides the metrics for one glyph:

    struct nx_fontmetric_s
    {
      uint32_t stride   : 2;      /* Width of one font row in bytes */
      uint32_t width    : 6;      /* Width of the font in bits */
      uint32_t height   : 6;      /* Height of the font in rows */
      uint32_t xoffset  : 6;      /* Top, left-hand corner X-offset in pixels */
      uint32_t yoffset  : 6;      /* Top, left-hand corner y-offset in pixels */
      uint32_t unused   : 6;
    };

This structure binds the glyph metrics to the glyph bitmap:

    struct nx_fontbitmap_s
    {
      struct nx_fontmetric_s metric; /* Character metrics */
      FAR const uint8_t *bitmap;     /* Pointer to the character bitmap */
    };

This structure describes one contiguous grouping of glyphs that can be described by an array starting with encoding `first` and extending through (`first` + `nchars` - 1).

    struct nx_fontset_s
    {
      uint8_t  first;             /* First bitmap character code */
      uint8_t  nchars;            /* Number of bitmap character codes */
      FAR const struct nx_fontbitmap_s *bitmap;
    };

This structure describes the overall fontset:

    struct nx_font_s
    {
      uint8_t  mxheight;          /* Max height of one glyph in rows */
      uint8_t  mxwidth;           /* Max width of any glyph in pixels */
      uint8_t  mxbits;            /* Max number of bits per character code */
      uint8_t  spwidth;           /* The width of a space in pixels */
    };

### 2.5.2 `nxf_getfonthandle()`

Function Prototype:

    #include <nuttx/nx/nxfonts.h>

    NXHANDLE nxf_getfonthandle(enum nx_fontid_e fontid);

Description: Given a numeric font ID, return a handle that may be subsequently be used to access the font data sets.

Input Parameters:

`fontid`
  Identifies the font set to use

Returned Value: A handle that may be subsequently be used to access the font data sets.

### 2.5.3 `nxf_getfontset()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nxfonts.h>

    FAR const struct nx_font_s *nxf_getfontset(NXHANDLE handle);

Description: Return information about the current font set.

Input Parameters:

`handle`
  A font handle previously returned by `nxf_getfonthandle()`.

Returned Value: An instance of `struct nx_font_s` describing the font set.

### 2.5.4 `nxf_getbitmap()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nxfonts.h>

    FAR const struct nx_fontbitmap_s *nxf_getbitmap(NXHANDLE handle, uint16_t ch);

Description: Return font bitmap information for the selected character encoding.

Input Parameters:

`ch`
  The char code for the requested bitmap.
`handle`
  A font handle previously returned by `nxf_getfonthandle()`.

Returned Value: An instance of `struct nx_fontbitmap_s` describing the glyph.

### 2.5.5 `nxf_convert_*bpp()`

Function Prototype:

    #include <nuttx/nx/nxglib.h>
    #include <nuttx/nx/nxfonts.h>

    int nxf_convert_2bpp(FAR uint8_t *dest, uint16_t height,
                         uint16_t width, uint16_t stride,
                         FAR const struct nx_fontbitmap_s *bm,
                         nxgl_mxpixel_t color);
    int nxf_convert_4bpp(FAR uint8_t *dest, uint16_t height,
                         uint16_t width, uint16_t stride,
                         FAR const struct nx_fontbitmap_s *bm,
                         nxgl_mxpixel_t color);
    int nxf_convert_8bpp(FAR uint8_t *dest, uint16_t height,
                         uint16_t width, uint16_t stride,
                         FAR const struct nx_fontbitmap_s *bm,
                         nxgl_mxpixel_t color);
    int nxf_convert_16bpp(FAR uint16_t *dest, uint16_t height,
                          uint16_t width, uint16_t stride,
                          FAR const struct nx_fontbitmap_s *bm,
                          nxgl_mxpixel_t color);
    int nxf_convert_24bpp(FAR uint32_t *dest, uint16_t height,
                          uint16_t width, uint16_t stride,
                          FAR const struct nx_fontbitmap_s *bm,
                          nxgl_mxpixel_t color);
    int nxf_convert_32bpp(FAR uint32_t *dest, uint16_t height,
                          uint16_t width, uint16_t stride,
                          FAR const struct nx_fontbitmap_s *bm,
                          nxgl_mxpixel_t color);

Description: Convert the 1BPP font to a new pixel depth.

Input Parameters:

`dest`
  The destination buffer provided by the caller.
`height`
  The max height of the returned char in rows.
`width`
  The max width of the returned char in pixels.
`stride`
  The width of the destination buffer in bytes.
`bm`
  Describes the character glyph to convert
`color`
  The color to use for '1' bits in the font bitmap (0 bits are transparent).

Returned Value: `OK` on success; `ERROR` on failure with `errno` set appropriately.

## 2.6 Sample Code

`apps/examples/nx*`. No sample code is provided in this document. However, examples can be found in the NuttX source tree at the follow locations: That example code is intended to test NX. Since it is test code, it is designed to exercise functionality and does not necessarily represent best NX coding practices.

- `apps/examples/nx`. This is a test of windows, optionally with toolbars. Two windows are created, re-sized, moved, raise lowered. Simulated mouse and keyboard input is provided.
- `apps/examples/nxhello`. This is intended to be simplest NX test: It simply displays the words "Hello, World!" centered on the display.
- `apps/examples/nxtext`. This illustrates how fonts may be managed to provide scrolling text windows. Pop-up windows are included to verify the clipping and re-drawing of the text display.

In its current form, the NX graphics system provides a low level of graphics and window support. Most of the complexity of manage redrawing and handling mouse and keyboard events must be implemented by the NX client code.

Building `apps/examples/nx`. Testing was performed using the Linux/Cygwin-based NuttX simulator. Instructions are provided for building that simulation are provided in Appendix C of this document.

# Appendix A `graphics/` Directory Structure

The graphics capability consist both of components internal to the RTOS and of user-callable interfaces. In the NuttX kernel mode build there are some components of the graphics subsystem are callable in user mode and other components that are internal to the RTOS. The directory `nuttx/graphics` contains only those components that are internal to the RTOS. User callable functions must be part of a library that can be linked against user applications. This user callable interfaces are provided in sub-directories under `nuttx/libnx`.

`libnx/nx`
  Common callable interfaces that are, logically, part of both nxmu and nxsu.
`graphics/nxglib` and `libnx/nxglib`
  The NuttX tiny graphics library. The directory contains generic utilities support operations on primitive graphics objects and logic to rasterize directly into a framebuffer or through an LCD driver interface. It has no concept of windows (other than the one, framebuffer or LCD window).
`graphics/nxbe`
  This is the back-end of a tiny windowing system. It can be used with either of two front-ends to complete a windowing system (see `nxmu` and `nxsu` below). It contains most of the important window management logic: clipping, window controls, window drawing, etc.
`graphics/nxsu`1
  This is the NX single user front end. When combined with the generic back-end (`nxbe`), it implements a single threaded, single user windowing system. The files in this directory present the window APIs described in `include/nuttx/nx/nx.h`. The single user front-end is selected when `CONFIG_NX_MULTIUSER` is not defined in the NuttX configuration file.
`graphics/nxmu` and `libnx/nxmu`
  This is the NX multi user front end. When combined with the generic back-end (`nxbe`), it implements a multi-threaded, multi-user windowing system. The files in this directory present the window APIs described in `include/nuttx/nx/nx.h`. The multi-user front end includes a graphics server that executes on its own thread; multiple graphics clients then communicate with the server via a POSIX message queue to serialize window operations from many threads. The multi-user front-end is selected when `CONFIG_NX_MULTIUSER` is defined in the NuttX configuration file.
`libnx/nxfonts`
  This is where the NXFONTS implementation resides. This is a relatively low-level set of charset set/glyph management APIs. See `include/nuttx/nx/nxfonts.h`.
`libnx/nxtk`
  This is where the NXTOOLKIT implementation resides. This toolkit is built on top of NX and works with either the single-user or multi-user NX version. See `include/nuttx/nx/nxtk.h`.
`nuttx/../nxwidgets`
  The NxWidgets code is provided as a separate package located outside of the NuttX source tree (probably at this location).
`graphics/nxterm`
  The NxTerm driver is built on top of NX and works with either the single-user or multi-user NX version. See `include/nuttx/nx/nxterm.h`.

1There is no nxsu sub-directory in nuttx/libnx. That is because this separation of interfaces is only required in the kernel build mode and only the multi-user interfaces can be used with the kernel build.

# Appendix B NX Configuration Options

## B.1 General Configuration Settings

`CONFIG_NX` Enables overall support for graphics library and NX

## B.2 NXGL Configuration Settings

`CONFIG_NX_NPLANES`:
  Some YUV color formats requires support for multiple planes, one for each color component. Unless you have such special hardware, this value should be undefined or set to 1.
`CONFIG_NX_DISABLE_1BPP`, `CONFIG_NX_DISABLE_2BPP`, `CONFIG_NX_DISABLE_4BPP`, `CONFIG_NX_DISABLE_8BPP` `CONFIG_NX_DISABLE_16BPP`, `CONFIG_NX_DISABLE_24BPP`, and `CONFIG_NX_DISABLE_32BPP`:
  NX supports a variety of pixel depths. You can save some memory by disabling support for unused color depths.
`CONFIG_NX_PACKEDMSFIRST`:
  If a pixel depth of less than 8-bits is used, then NX needs to know if the pixels pack from the MS to LS or from LS to MS
`CONFIG_NX_LCDDRIVER`:
  By default, NX builds to use a framebuffer driver (see `include/nuttx/video/fb.h`). If this option is defined, NX will build to use an LCD driver (see `include/nuttx/lcd/lcd.h`).

## B.3 NX Configuration Settings

`CONFIG_NX_XYINPUT`:
  Build in support for an X/Y input such as a mouse or a touscreen.
`CONFIG_NX_KBD`:
  Build in support of keypad/keyboard input.
`CONFIG_NX_WRITEONLY`:
  Define if the underlying graphics device does not support read operations. Automatically defined if `CONFIG_NX_LCDDRIVER` and `CONFIG_LCD_NOGETRUN` are defined.

## B.4 NX Multi-User (Only) Configuration Settings

`CONFIG_NX_MULTIUSER`:
  Configures NX in multi-user mode.
`CONFIG_NX_BLOCKING`
  Open the client message queues in blocking mode. In this case, `nx_eventhandler()` will not return until a message is received and processed.
`CONFIG_NX_MXSERVERMSGS` and `CONFIG_NX_MXCLIENTMSGS`
  Specifies the maximum number of messages that can fit in the message queues. No additional resources are allocated, but this can be set to prevent flooding of the client or server with too many messages (`CONFIG_PREALLOC_MQ_MSGS` controls how many messages are pre-allocated).

## B.5 NXTK Configuration Settings

`CONFIG_NXTK_BORDERWIDTH`:
  Specifies with with of the border (in pixels) used with framed windows. The default is 4.
`CONFIG_NXTK_BORDERCOLOR1`, `CONFIG_NXTK_BORDERCOLOR2`, and `CONFIG_NXTK_BORDERCOLOR3`:
  Specify the colors of the border used with framed windows.
`CONFIG_NXTK_BORDERCOLOR2`
  The shadow side color and so is normally darker.
`CONFIG_NXTK_BORDERCOLOR3`
  The shiny side color and so is normally brighter. The default is medium, dark, and light grey, respectively
`CONFIG_NXTK_AUTORAISE`:
  If set, a window will be raised to the top if the mouse position is over a visible portion of the window. Default: A mouse button must be clicked over a visible portion of the window.

## B.6 NXFONTS Configuration Settings

`CONFIG_NXFONTS_CHARBITS`:
  The number of bits in the character set. Current options are only 7 and 8. The default is 7.
`CONFIG_NXFONT_SANS17X22`:
  This option enables support for a tiny, 17x22 san serif font (font `ID FONTID_SANS17X22` == 14).
`CONFIG_NXFONT_SANS20X26`:
  This option enables support for a tiny, 20x26 san serif font (font `ID FONTID_SANS20X26` == 15).
`CONFIG_NXFONT_SANS23X27`:
  This option enables support for a tiny, 23x27 san serif font (font `ID FONTID_SANS23X27` == 1).
`CONFIG_NXFONT_SANS22X29`:
  This option enables support for a small, 22x29 san serif font (font `ID FONTID_SANS22X29` == 2).
`CONFIG_NXFONT_SANS28X37`:
  This option enables support for a medium, 28x37 san serif font (font `ID FONTID_SANS28X37` == 3).
`CONFIG_NXFONT_SANS39X48`:
  This option enables support for a large, 39x48 san serif font (font `ID FONTID_SANS39X48` == 4).
`CONFIG_NXFONT_SANS17X23B`:
  This option enables support for a tiny, 17x23 san serif bold font (font `ID FONTID_SANS17X23B` == 16).
`CONFIG_NXFONT_SANS20X27B`:
  This option enables support for a tiny, 20x27 san serif bold font (font `ID FONTID_SANS20X27B` == 17).
`CONFIG_NXFONT_SANS22X29B`:
  This option enables support for a small, 22x29 san serif bold font (font ID `FONTID_SANS22X29B` == 5).
`CONFIG_NXFONT_SANS28X37B`:
  This option enables support for a medium, 28x37 san serif bold font (font ID `FONTID_SANS28X37B` == 6).
`CONFIG_NXFONT_SANS40X49B`:
  This option enables support for a large, 40x49 san serif bold font (font ID `FONTID_SANS40X49B` == 7).
`CONFIG_NXFONT_SERIF22X29`:
  This option enables support for a small, 22x29 font (with serifs) (font ID `FONTID_SERIF22X29` == 8).
`CONFIG_NXFONT_SERIF29X37`:
  This option enables support for a medium, 29x37 font (with serifs) (font ID `FONTID_SERIF29X37` == 9).
`CONFIG_NXFONT_SERIF38X48`:
  This option enables support for a large, 38x48 font (with serifs) (font ID `FONTID_SERIF38X48` == 10).
`CONFIG_NXFONT_SERIF22X28B`:
  This option enables support for a small, 27x38 bold font (with serifs) (font ID `FONTID_SERIF22X28B` == 11).
`CONFIG_NXFONT_SERIF27X38B`:
  This option enables support for a medium, 27x38 bold font (with serifs) (font ID `FONTID_SERIF27X38B` == 12).
`CONFIG_NXFONT_SERIF38X49B`:
  This option enables support for a large, 38x49 bold font (with serifs) (font ID `FONTID_SERIF38X49B` == 13).

## B.7 NxTerm Configuration Settings

General NxTerm settings.

`CONFIG_NXTERM`:
  Enables building of the NxTerm driver.

NxTerm output text/graphics options:

`CONFIG_NXTERM_BPP`:
  Currently, NxTerm supports only a single pixel depth. This configuration setting must be provided to support that single pixel depth. Default: The smallest enabled pixel depth. (see `CONFIG_NX_DISABLE_*BPP`)
`CONFIG_NXTERM_CURSORCHAR`:
  The bitmap code to use as the cursor. Default '_'
`CONFIG_NXTERM_MXCHARS`:
  NxTerm needs to remember every character written to the console so that it can redraw the window. This setting determines the size of some internal memory allocations used to hold the character data. Default: 128.
`CONFIG_NXTERM_CACHESIZE`:
  NxTerm supports caching of rendered fonts. This font caching is required for two reasons: (1) First, it improves text performance, but more importantly (2) it preserves the font memory. Since the NX server runs on a separate server thread, it requires that the rendered font memory persist until the server has a chance to render the font. Unfortunately, the font cache would be quite large if all fonts were saved. The `CONFIG_NXTERM_CACHESIZE` setting will control the size of the font cache (in number of glyphs). Only that number of the most recently used glyphs will be retained. Default: 16.

  > NOTE: There can still be a race condition between the NxTerm driver and the NX task. If you every see character corruption (especially when printing a lot of data or scrolling), then increasing the value of `CONFIG_NXTERM_CACHESIZE` is something that you should try. Alternatively, you can reduce the size of `CONFIG_MQ_MAXMSGSIZE` which will force NxTerm task to pace the server task. `CONFIG_NXTERM_CACHESIZE` should be larger than `CONFIG_MQ_MAXMSGSIZE` in any event.

`CONFIG_NXTERM_LINESEPARATION`:
  This the space (in rows) between each row of test. Default: 0
`CONFIG_NXTERM_NOWRAP`:
  By default, lines will wrap when the test reaches the right hand side of the window. This setting can be defining to change this behavior so that the text is simply truncated until a new line is encountered.

NxTerm input options:

`CONFIG_NXTERM_NXKBDIN`:
  Take input from the NX keyboard input callback. By default, keyboard input is taken from stdin (`/dev/console`). If this option is set, then the interface`nxterm_kdbin()` is enabled. That interface may be driven by window callback functions so that keyboard input only goes to the top window.
`CONFIG__NXTERM_KBDBUFSIZE`:
  If `CONFIG_NXTERM_NXKBDIN` is enabled, then this value may be used to define the size of the per-window keyboard input buffer. Default: 16
`CONFIG_NXTERM_NPOLLWAITERS`:
  The number of threads that can be waiting for read data available. Default: 4

# Appendix C Installing New Fonts

The BDF Font Converter. There is a tool called bdf-converter in the directory `tools/.`. The bdf-converter program be used to convert fonts in Bitmap Distribution Format (BDF) into fonts that can be used in the NX graphics system. The BDF format most well known as a font format traditionally used for X-11 bitmap fonts.

> A Note about Font Copyrights: My understanding is that the underlying bitmap font data for traditional fonts cannot be copyrighted (the same is not true for scalable fonts). This is because a copyright covers only the form of delivery of the font and not the underlying font content and, at least for the traditional typefaces, the underlying font designs are ancient. There could be issues, however, if you convert from modern, trademarked images. However, remember that I am a programmer not an attorney and that my knowledge of font copyright issues is limited to what I glean by Googling.

Font Installation Steps, Below are general instructions for creating and installing a new font in the NX graphic system. The first two steps only appy if you are using the BDF font converter program.

1. Locate a font in BDF format. There are many good BDF bitmap fonts bundled with X-11. See this link, as an example,

2. Use the bdf-converter program to convert the BDF font to the NuttX font format. This will result in a C header file containing definitions. That header file should be installed at, for example, `graphics/nxfonts/nxfonts_myfont.h`.

The remaining steps apply however you managed to create the NuttX C font header file. After you have your C font header file, the next thing to do is to create a new NuttX configuration variable to select the font. For example, suppose you define the following variable: `CONFIG_NXFONT_MYFONT`. Then you would need to:

3. Define `CONFIG_NXFONT_MYFONT=y` in your NuttX configuration file.

A font ID number has to be assigned for each new font. The font IDs are defined in the file `include/nuttx/nx/nxfonts.h`. Those definitions have to be extended to support your new font. Look at how the font ID enabled by `CONFIG_NXFONT_SANS23X27` is defined and add an ID for yournew font in a similar fashion:

4. `include/nuttx/nx/nxfonts.h`. Add you new font as a possible system default font:

       #if defined(CONFIG_NXFONT_SANS23X27)
       # define NXFONT_DEFAULT FONTID_SANS23X27
       #elif defined(CONFIG_NXFONT_MYFONT)
       # define NXFONT_DEFAULT FONTID_MYFONT
       #endif

   Then define the actual font ID. Make sure that the font ID value is unique:

       enum nx_fontid_e
       {
         FONTID_DEFAULT     = 0      /* The default font */
       #ifdef CONFIG_NXFONT_SANS23X27
         , FONTID_SANS23X27 = 1      /* The 23x27 sans serif font */
       #endif
       #ifdef CONFIG_NXFONT_MYFONT
         , FONTID_MYFONT    = 2      /* My shiny, new font */
       #endif
       ...

New Add the font to the NX build system. There are several files that you have to modify to to this. Look how the build system uses the font CONFIG_NXFONT_SANS23X27 for examaples:

5. `nuttx/graphics/Makefile`. This file needs logic to auto-generate a C source file from the header file that you generated with the bdf-converter program. Notice `NXFONTS_FONTID=2`; this must be set to the same font ID value that you defined in the `include/nuttx/nx/nxfonts.h` file.

       genfontsources:
         ifeq ($(CONFIG_NXFONT_SANS23X27),y)
             @$(MAKE) -C nxfonts -f Makefile.sources TOPDIR=$(TOPDIR) NXFONTS_FONTID=1 EXTRADEFINES=$(EXTRADEFINES)
         endif
         ifeq ($(CONFIG_NXFONT_MYFONT),y)
             @$(MAKE) -C nxfonts -f Makefile.sources TOPDIR=$(TOPDIR) NXFONTS_FONTID=2 EXTRADEFINES=$(EXTRADEFINES)
         endif

6. `nuttx/graphics/nxfonts/Make.defs`. Set the make variable `NXFSET_CSRCS`. `NXFSET_CSRCS` determines the name of the font C file to build when `NXFONTS_FONTID=2`:

       ifeq ($(CONFIG_NXFONT_SANS23X27),y)
       NXFSET_CSRCS += nxfonts_bitmaps_sans23x27.c
       endif
       ifeq ($(CONFIG_NXFONT_MYFONT),y)
       NXFSET_CSRCS += nxfonts_bitmaps_myfont.c
       endif

7. `nuttx/graphics/nxfonts/Makefile.sources`. This is the Makefile used in step 5 that will actually generate the font C file. So, given your NXFONTS_FONTID=2, it needs to determine a prefix to use for auto-generated variable and function names and (again) the name of the autogenerated file to create (this must be the same name that was used in `nuttx/graphics/nxfonts/Make.defs`):

       ifeq ($(NXFONTS_FONTID),1)
       NXFONTS_PREFIX	:= g_sans23x27_
       GEN_CSRC	= nxfonts_bitmaps_sans23x27.c
       endif
       ifeq ($(NXFONTS_FONTID),2)
       NXFONTS_PREFIX	:= g_myfont_
       GEN_CSRC	= nxfonts_bitmaps_myfont.c
       endif

8. `graphics/nxfonts/nxfonts_bitmaps.c`. This is the file that contains the generic font structures. It is used as a "template&qout; file by `nuttx/graphics/nxfonts/Makefile.sources` to create your customized font data set at build time.

       #if NXFONTS_FONTID == 1
       #  include "nxfonts_sans23x27.h"
       #elif NXFONTS_FONTID == 2
       #  include "nxfonts_myfont.h"
       #else
       #  error "No font ID specified"
       #endif

   Where `nxfonts_myfont.h` is the NuttX font file that we generated in step 2 using the bdf-converter tool.

9. `graphics/nxfonts/nxfonts_getfont.c`. Finally, we need to extend the logic that does the run-time font lookups so that can find our new font. The lookup function is `NXHANDLE nxf_getfonthandle(enum nx_fontid_e fontid)`. Note that the lookup is based on the font ID that was defined in step 4. The new font information needs to be added to data structures used by that function:

       #ifdef CONFIG_NXFONT_SANS23X27
       extern const struct nx_fontpackage_s g_sans23x27_package;
       #endif
       #ifdef CONFIG_NXFONT_MYFONT
       extern const struct nx_fontpackage_s g_myfont_package;
       #endif

       static FAR const struct nx_fontpackage_s *g_fontpackages[] =
       {
       #ifdef CONFIG_NXFONT_SANS23X27
         &g_sans23x27_package,
       #endif
       #ifdef CONFIG_NXFONT_MYFONT
         &g_myfont_package,
       #endif
         NULL
       };

# Appendix D NX Test Coverage

`apps/examples/nx`. The primary test tool for debugging NX resides at `apps/examples/nx`.

Building `apps/examples/nx`. NX testing was performed using `apps/examples/nx` with the Linux/Cygwin-based NuttX simulator. Configuration files for building this test can be found in `configs/sim/nx` and `configs/sim/nx11`. There are two alternative configurations for building the simulation:

1. The configuration using the configuration file at `configs/sim/nx/defconfig`. This default configuration exercises the NX logic a 8 BPP but provides no visual feedback. In this configuration, a very simple, simulated framebuffer driver is used that is based upon a simple region of memory posing as video memory. That default configuration can be built as follows:

       cd <NuttX-Directory>/tools
       ./configure sim/nx
       cd  <NuttX-Directory>
       make
       ./nuttx

2. The preferred configuration is at `configs/sim/nx11/defconfig`. This configuration extends the test with a simulated framebuffer driver that uses an X window as a framebuffer. This is a superior test configuration because the X window appears at your desktop and you can see the NX output. This preferred configuration can be built as follows:

       cd <NuttX-Directory>/tools
       ./configure sim/nx11
       cd  <NuttX-Directory>
       make
       ./nuttx

   Update: The sim target has suffered some bit-rot over the years and so the following caveats need to be added:

   - The X target builds under recent Cygwin configurations, but does not execute. (It fails inside of `XOpenDisplay()`.

   - The X target does not build under current (9.09) Ubuntu distributions. I needed to make the following changes:

     cd /usr/lib/ sudo ln -s libXext.so.6.4.0 libXext.so

     The build will also fail to locate the X header files unless you install an X11 development package.

   - The sim target itself is broken under 64-bit Linux. This is because the sim target is based upon some assembly language setjmp/longjmp logic that only works on 32-bit systems.

     NOTE: There is a workaround in this case: You can build for 32-bit execution on a 64-bit machine by adding `-m3` to the `CFLAGS` and `-m32 -m elf_i386` to the `LDFLAGS`. See the patch file `0001-Quick-hacks-to-build-sim-nsh-ostest-on-x86_64-as-32-.patch` that can be found in NuttX files.

   - Refer to the readme file in sim configuration README.txt file for additional information.

Test Coverage. At present, `apps/examples/nx`t only exercises a subset of NX; the remainder is essentially untested. The following table describes the testing performed on each NX API:

## Table D.1: NXGLIB API Test Coverage

Function | Special Setup/Notes | Verified
--- | --- | ---
`nxgl_rgb2yuv()` |  | NO
`nxgl_yuv2rgb()` |  | NO
`nxgl_rectcopy()` |  | YES
`nxgl_rectoffset()` |  | YES
`nxgl_vectoradd()` |  | YES
`nxgl_vectorsubtract()` |  | YES
`nxgl_rectintersect()` |  | YES
`nxgl_rectunion()` |  | YES
`nxgl_nonintersecting()` |  | YES
`nxgl_rectoverlap()` |  | YES
`nxgl_rectinside()` |  | YES
`nxgl_rectsize()` |  | YES
`nxgl_nullrect()` |  | YES
`nxgl_runoffset()` | Verified by `apps/examples/nxlines`. | YES
`nxgl_runcopy()` |  | NO
`nxgl_trapoffset()` | Verified by `apps/examples/nxlines`. | YES
`nxgl_trapcopy()` | Verified by `apps/examples/nxlines`. | YES
`nxgl_colorcopy` |  | YES
`nxgl_splitline` | Verified using `apps/examples/nxlines`. Generally works well, but has some accuracy/overflow problems wide lines that are nearly horizontal. There is a "fudge factor" that seems to eliminate the problem, but there could still be issues in some configurations. | YES
`nxgl_circlepts` | Verified by `apps/examples/nxlines`. | YES
`nxgl_circletraps` | Verified by `apps/examples/nxlines`. | YES

## Table D.2: NX Server Callbacks Test Coverage

Function | Special Setup/Notes | Verified
--- | --- | ---
`redraw()` |  | YES
`position()` |  | YES
`mousein()` |  | YES
`kbdin()` |  | YES

## Table D.3: NX API Test Coverage

Function | Special Setup/Notes | Verified
--- | --- | ---
`nx_runinstance()` | Change to `CONFIG_NX_MULTIUSER=y` in the `<NuttX-Directory>/.config` file | YES
`nx_connectinstance()` | Change to `CONFIG_NX_MULTIUSER=y` in the `<NuttX-Directory>/.config` file | YES
`nx_open()` |  | YES
`nx_disconnect()` | Change to `CONFIG_NX_MULTIUSER=y` in the `<NuttX-Directory>/.config` file | YES
`nx_close()` |  | YES
`nx_eventhandler()` | Change to `CONFIG_NX_MULTIUSER=y` in the `<NuttX-Directory>/.config` file | YES
`nx_eventnotify()` | This is not used in the current version of `apps/examples/nx`, was tested in a previous version) | NO
`nx_openwindow()` | Change to `CONFIG_EXAMPLES_NX_RAWWINDOWS=y` in the `<NuttX-Directory>/.config` file | YES
`nx_closewindow()` | Change to `CONFIG_EXAMPLES_NX_RAWWINDOWS=y` in the `<NuttX-Directory>/.config` file | YES
`nx_requestbkgd()` | Verified by `apps/examples/nxtext` and `apps/examples/nxhello`. | YES
`nx_releasebkgd()` | Verified by `apps/examples/nxtext` and `apps/examples/nxhello`. | YES
`nx_getposition()` |  | NO
`nx_setposition()` | Change to `CONFIG_EXAMPLES_NX_RAWWINDOWS=y` in the `<NuttX-Directory>/.config` file | YES
`nx_setsize()` | Change to `CONFIG_EXAMPLES_NX_RAWWINDOWS=y` in the `<NuttX-Directory>/.config` file | YES
`nx_raise()` | Change to `CONFIG_EXAMPLES_NX_RAWWINDOWS=y` in the `<NuttX-Directory>/.config` file | YES
`nx_lower()` | Change to `CONFIG_EXAMPLES_NX_RAWWINDOWS=y` in the `<NuttX-Directory>/.config` file | YES
`nx_fill()` | Change to `CONFIG_EXAMPLES_NX_RAWWINDOWS=y` in the `<NuttX-Directory>/.config` file | YES
`nx_getrectangle()` |  | YES
`nx_filltrapezoid()` | Verified by `apps/examples/nxlines`. | YES
`nx_drawline()` | Verified by `apps/examples/nxlines`. | YES
`nx_drawcircle()` | Verified by `apps/examples/nxlines`. | YES
`nx_fillcircle()` | Verified by `apps/examples/nxlines`. | YES
`nx_setbgcolor()` |  | YES
`nx_move()` | Change to `CONFIG_EXAMPLES_NX_RAWWINDOWS=y` in the `<NuttX-Directory>/.config` file | YES
`nx_bitmap()` | Change to `CONFIG_EXAMPLES_NX_RAWWINDOWS=y` in the `<NuttX-Directory>/.config` file. | YES
`nx_kbdin()` |  | YES
`nx_mousein()` |  | YES

## Table D.4: NXTK API Test Coverage

Function | Special Setup/Notes | Verified
--- | --- | ---
`nxtk_openwindow()` |  | YES
`nxtk_closewindow()` |  | YES
`nxtk_getposition()` |  | NO
`nxtk_setposition()` |  | YES
`nxtk_setsize()` |  | YES
`nxtk_raise()` |  | YES
`nxtk_lower()` |  | YES
`nxtk_fillwindow()` |  | YES
`nxtk_getwindow()` |  | NO
`nxtk_filltrapwindow()` |  | NO
`nxtk_drawlinewindow()` |  | YES
`nxtk_drawcirclewindow()` |  | YES
`nxtk_fillcirclewindow()` |  | YES
`nxtk_movewindow()` |  | NO
`nxtk_bitmapwindow()` |  | YES
`nxtk_opentoolbar()` |  | YES
`nxtk_closetoolbar()` |  | YES
`nxtk_filltoolbar()` |  | YES
`nxtk_gettoolbar()` |  | NO
`nxtk_filltraptoolbar()` |  | NO
`nxtk_drawlinetoolbar()` |  | NO
`nxtk_drawcircletoolbar()` |  | NO
`nxtk_fillcircletoolbar()` |  | NO
`nxtk_movetoolbar()` |  | NO
`nxtk_bitmaptoolbar()` |  | NO

## Table D.5: NXFONTS API Test Coverage

Function | Special Setup/Notes | Verified
--- | --- | ---
`nxf_getfonthandle()` |  | YES
`nxf_getfontset()` |  | YES
`nxf_getbitmap()` |  | YES
`nxf_convert_2bpp()` |  | NO
`nxf_convert_4bpp()` |  | NO
`nxf_convert_8bpp()` | Use `defconfig` when building. | YES
`nxf_convert_16bpp()` |  | YES
`nxf_convert_24bpp()` |  | NO
`nxf_convert_32bpp()` |  | YES